autodefine "off"
$use "b3d.lib"
CONST BBFALSE= 0
CONST BBTRUE= 1

CONST GFX_DEFAULT= 0
CONST GFX_FULLSCREEN= 1
CONST GFX_WINDOWED= 2
CONST GFX_WINDOWEDSCALED= 3

CONST PROJ_NONE= 0
CONST PROJ_PERSPECTIVE= 1
CONST PROJ_ORTHO= 2

CONST LIGHTDIRECTIONAL= 1
CONST LIGHTPOINT= 2
CONST LIGHTSPOT= 3

CONST TX_COLOR= 1
CONST TX_ALPHA= 2
CONST TX_MASKED= 4
CONST TX_MIP= 8
CONST TX_CLAMPU =16
CONST TX_CLAMPV= 32
CONST TX_SPHERE= 64
CONST TX_CUBIC= 128
CONST TX_VRAM= 256
CONST TX_HIGHCOLOR= 512

CONST TX_BLEND_NONE= 0
CONST TX_BLEND_ALPHA= 1
CONST TX_BLEND_MULT= 2
CONST TX_BLEND_ADD= 3
CONST TX_BLEND_DOT3= 4
CONST TX_BLEND_MULT2= 5

CONST CUBEFACE_LEFT= 0
CONST CUBEFACE_FRONT= 1
CONST CUBEFACE_RIGHT= 2
CONST CUBEFACE_BACK= 3
CONST CUBEFACE_TOP= 4
CONST CUBEFACE_BOTTOM= 5

CONST CUBEMODE_SPECULAR= 1
CONST CUBEMODE_DIFFUSE= 2
CONST CUBEMODE_REFRACTION= 3

CONST BRUSHBLEND_NONE =0
CONST BRUSHBLEND_MULTIPLY =1
CONST BRUSHBLEND_ALPHA =2
CONST BRUSHBLEND_ADD =3

CONST BRUSHFX_NONE =0
CONST BRUSHFX_FULLBRIGHT =1
CONST BRUSHFX_VERTEXCOLOR= 2
CONST BRUSHFX_FLAT =4
CONST BRUSHFX_NOFOG =8
CONST BRUSHFX_DOUBLESIDED= 16
CONST BRUSHFX_VERTEXALPHA= 32

CONST COLLIDE_SPHERESPHERE= 1
CONST COLLIDE_SPHEREPOLY =2
CONST COLLIDE_SPHEREBOX =3

CONST COLLIDE_STOP =1
CONST COLLIDE_SLIDE1= 2
CONST COLLIDE_SLIDE2 =3

CONST PICK_NONE =0
CONST PICK_SPHERE= 1
CONST PICK_POLY =2
CONST PICK_BOX =3

CONST ANIMSTOP =0
CONST ANIMLOOP =1
CONST ANIMPINGPONG= 2
CONST ANIMONCE =3

CONST SPRITE_TURNXY= 1
CONST SPRITE_STILL =2
CONST SPRITE_ALIGNZ =3
CONST SPRITE_TURNY= 4

CONST PLAYCD_SINGLE= 1
CONST PLAYCD_LOOP =2
CONST PLAYCD_ALL =3

CONST MOUSE_BUTTON= 1
CONST MOUSE_RIGHTBUTTON= 2
CONST MOUSE_MIDDLEBUTTON= 3

CONST JOYTYPE_NONE =0
CONST JOYTYPE_DIGITAL= 1 
CONST JOYTYPE_ANALOG =2

CONST KEY_ESCAPE =1
CONST KEY_TAB =15
CONST KEY_SPACE= 57
CONST KEY_RETURN= 28
CONST KEY_LEFTSHIFT= 42
CONST KEY_LEFTCONTROL= 29
CONST KEY_LEFTALT =56
CONST KEY_RIGHTSHIFT= 54
CONST KEY_RIGHTCONTROL= 157
CONST KEY_RIGHTALT =184
 
CONST KEY_UP =200
CONST KEY_LEFT= 203
CONST KEY_RIGHT= 205
CONST KEY_DOWN= 208
 
CONST KEY_F1 =59
CONST KEY_F2 =60 
CONST KEY_F3 =61
CONST KEY_F4 =62
CONST KEY_F5 =63
CONST KEY_F6 =64
CONST KEY_F7 =65
CONST KEY_F8 =66
CONST KEY_F9 =67
CONST KEY_F10 =68

CONST KEY_Q =16
CONST KEY_W =17
CONST KEY_E =18
CONST KEY_R =19
CONST KEY_T =20 
CONST KEY_Y =21
CONST KEY_U =22
CONST KEY_I =23
CONST KEY_O =24
CONST KEY_P =25
 
CONST KEY_A =30 
CONST KEY_S =31
CONST KEY_D =32
CONST KEY_F =33
CONST KEY_G =34
CONST KEY_H =35
CONST KEY_J =36
CONST KEY_K =37
CONST KEY_L =38
 
CONST KEY_Z =44
CONST KEY_X =45
CONST KEY_C =46
CONST KEY_V =47
CONST KEY_B =48
CONST KEY_N =49
CONST KEY_M =50 
 
CONST KEY_1 =2
CONST KEY_2 =3
CONST KEY_3 =4
CONST KEY_4 =5
CONST KEY_5 =6
CONST KEY_6 =7
CONST KEY_7 =8
CONST KEY_8 =9
CONST KEY_9 =10 
CONST KEY_0 =11

CONST KEY_MINUS =12
CONST KEY_EQUALS =13
CONST KEY_BACKSPACE =14
CONST KEY_LEFTBRACKET =26
CONST KEY_RIGHTBRACKET =27
CONST KEY_SEMICOLON =39
CONST KEY_APOSTROPHE =40 
CONST KEY_GRAVE =41
CONST KEY_BACKSLASH =43
CONST KEY_COMMA =51
CONST KEY_PERIOD =52
CONST KEY_SLASH =53
CONST KEY_CAPSLOCK =58
 
CONST KEY_PRINT =183
CONST KEY_SCROLLLOCK =70 
CONST KEY_PAUSEBREAK =197
CONST KEY_INSERT =210
CONST KEY_DELETE =211
CONST KEY_HOME =199
CONST KEY_END =207
CONST KEY_PAGEUP =201
CONST KEY_PAGEDOWN =209

CONST KEY_NUMLOCK =69
CONST KEY_NUMPADDIVIDE =181
CONST KEY_NUMPADMULT =55
CONST KEY_NUMPADMINUS =74
CONST KEY_NUMPADPLUS =78
CONST KEY_NUMPADENTER =156
CONST KEY_NUMPADDOT =83
CONST KEY_NUMPAD0 =82
CONST KEY_NUMPAD1 =79
CONST KEY_NUMPAD2 =80 
CONST KEY_NUMPAD3 =81
CONST KEY_NUMPAD4 =75
CONST KEY_NUMPAD5 =76
CONST KEY_NUMPAD6 =77
CONST KEY_NUMPAD7 =71
CONST KEY_NUMPAD8 =72
CONST KEY_NUMPAD9 =73

CONST KEY_F11 =87
CONST KEY_F12 =88
CONST KEY_LEFTWINDOWS =219
CONST KEY_RIGHTWINDOWS =220
CONST KEY_NUMPADEQUALS =141
CONST KEY_NUMPADCOMMA =179
CONST KEY_OEM_102 =86
CONST KEY_AT =145
CONST KEY_COLON =146
CONST KEY_UNDERLINE =147
CONST KEY_BREAK =149

CONST KEY_PREVIOUSTRACK =144
CONST KEY_NEXTTRACK =153
CONST KEY_MUTE =160
CONST KEY_PLAYPAUSE =162
CONST KEY_STOP =164
CONST KEY_VOLUMELESS =174
CONST KEY_VOLUMEMORE =176
 
CONST KEY_APPS =221
CONST KEY_POWER= 222
CONST KEY_SLEEP= 223
CONST KEY_WAKE =227

CONST KEY_WEBHOME =178
CONST KEY_WEBSEARCH =229
CONST KEY_WEBFAVORITES =230 
CONST KEY_WEBREFRESH =231
CONST KEY_WEBSTOP =232
CONST KEY_WEBFORWARD =233
CONST KEY_WEBBACK =234
 
CONST KEY_MYCOMPUTER =235
CONST KEY_CALCULATOR =161
CONST KEY_MAIL =236
CONST KEY_MEDIASELECT =237

'typeCONST void * BBObject
DEF BBObject: int

DEF BBTimer: INT
DEF BBSound: INT
DEF BBChannel: INT 

DEF BBGraphics: INT 
DEF BBImage: INT
DEF BBMovie: INT
DEF BBFont: INT
DEF BBCanvas: INT
DEF BBScene: INT

DEF BBLight: INT
DEF BBCamera: INT
DEF BBModel: INT
DEF BBEntity: INT
DEF BBSurface: INT
DEF BBTexture: INT
DEF BBBrush: INT
DEF BBPivot: INT
DEF BBSprite: INT
DEF BBPlaneModel: INT
DEF BBMeshModel: INT
DEF BBQ3BSPModel: INT
DEF BBMD2Model: INT
DEF BBMirror: INT
DEF BBTerrain: INT

DEF HWND: UINT
DEF HANDLE: UINT
DEF BOOL: int

'//bbruntime

DECLARE CDECL import,bbVersion(),int

DECLARE CDECL import,bbSetBlitz3DDebugMode(int debugmode)
DECLARE CDECL import,bbSetBlitz3DDebugCallback(int sub_b3dDebugCallback)
declare cdecl b3dDebugCallback(pointer message) '// custom function name
DECLARE CDECL import,bbSetBlitz3DEventCallback(int sub_b3dEventCallback)
declare cdecl b3dEventCallback(int hwnd,int msg,int wparam,int lparam),int '// custom function name

DECLARE CDECL import,bbSetBlitz3DHWND(int hwndparent)
DECLARE CDECL import,bbSetBlitz3DTitle(pointer title,pointer close)

DECLARE CDECL import,bbBeginBlitz3D(),int
DECLARE CDECL import,bbEndBlitz3D()

DECLARE CDECL import,bbRuntimeError(pointer p)
DECLARE CDECL import,bbSystemProperty(pointer name),pointer 

DECLARE CDECL import,bbMilliSecs(),int

DECLARE CDECL import,bbDelay( int ms )
DECLARE CDECL import,bbShowPointer()
DECLARE CDECL import,bbHidePointer()

DECLARE CDECL import,bbCreateTimer( int hz ),BBTimer
DECLARE CDECL import,bbFreeTimer(BBTimer itimer)
DECLARE CDECL import,bbWaitTimer(BBTimer itimer)

' bbinput

'keyboard
DECLARE CDECL import,bbKeyDown( int n ),int
DECLARE CDECL import,bbKeyHit( int n ),int
DECLARE CDECL import,bbGetKey(),int
DECLARE CDECL import,bbWaitKey(),int
DECLARE CDECL import,bbFlushKeys()

'mouse
DECLARE CDECL import,bbMouseDown( int n ),int
DECLARE CDECL import,bbMouseHit( int n ),int
DECLARE CDECL import,bbGetMouse(),int
DECLARE CDECL import,bbWaitMouse(),int
DECLARE CDECL import,bbMouseX(),int
DECLARE CDECL import,bbMouseY(),int
DECLARE CDECL import,bbMouseZ(),int
DECLARE CDECL import,bbMouseXSpeed(),int
DECLARE CDECL import,bbMouseYSpeed(),int
DECLARE CDECL import,bbMouseZSpeed(),int
DECLARE CDECL import,bbMoveMouse( int x,int y )
DECLARE CDECL import,bbFlushMouse()


DECLARE CDECL import,bbJoyType(OPT int port=0 ),int
DECLARE CDECL import,bbJoyDown( int n,OPT int port=0 ),int
DECLARE CDECL import,bbJoyHit( int n,OPT int port=0 ),int
DECLARE CDECL import,bbGetJoy( OPT int port=0 ),int
DECLARE CDECL import,bbWaitJoy( OPT int port=0 ),int
DECLARE CDECL import,bbJoyX( OPT int port=0 ),float
DECLARE CDECL import,bbJoyY( OPT int port=0 ),float
DECLARE CDECL import,bbJoyZ( OPT int port=0 ),float
DECLARE CDECL import,bbJoyU( OPT int port=0 ),float
DECLARE CDECL import,bbJoyV( OPT int port=0 ),float
DECLARE CDECL import,bbJoyPitch( OPT int port=0 ),float
DECLARE CDECL import,bbJoyYaw( OPT int port=0 ),float
DECLARE CDECL import,bbJoyRoll( OPT int port=0 ),float
DECLARE CDECL import,bbJoyHat( OPT int port=0 ),int
DECLARE CDECL import,bbJoyXDir( OPT int port=0 ),int
DECLARE CDECL import,bbJoyYDir( OPT int port=0 ),int
DECLARE CDECL import,bbJoyZDir( OPT int port=0 ),int
DECLARE CDECL import,bbJoyUDir( OPT int port=0 ),int
DECLARE CDECL import,bbJoyVDir( OPT int port=0 ),int

DECLARE CDECL import,bbFlushJoy()

' bbaudio


DECLARE CDECL import,bbLoadSound( pointer src,OPT int flags=0 ),BBSound

DECLARE CDECL import,bbFreeSound( BBSound sound )
DECLARE CDECL import,bbPlaySound( BBSound sound ),BBChannel
DECLARE CDECL import,bbLoopSound( BBSound sound )
DECLARE CDECL import,bbSoundPitch( BBSound sound,int pitch )
DECLARE CDECL import,bbSoundVolume( BBSound sound,float volume )
DECLARE CDECL import,bbSoundPan( BBSound sound,float pan )

DECLARE CDECL import,bbPlayMusic( pointer src,OPT int mode=1 ),BBChannel
DECLARE CDECL import,bbPlayCDTrack( int track,OPT int mode=1 ),BBChannel

DECLARE CDECL import,bbStopChannel( BBChannel channel )
DECLARE CDECL import,bbPauseChannel( BBChannel channel )
DECLARE CDECL import,bbResumeChannel( BBChannel channel )
DECLARE CDECL import,bbChannelPitch( BBChannel channel,int pitch )
DECLARE CDECL import,bbChannelVolume( BBChannel channel,float volume )
DECLARE CDECL import,bbChannelPan( BBChannel channel,float pan )
DECLARE CDECL import,bbChannelPlaying( BBChannel channel ),int

' bbgraphics
DECLARE CDECL import,bbGraphics3D( int w,int h,OPT int d=0,OPT int mode=0 )

DECLARE CDECL import,bbCountGfxDrivers(),int
DECLARE CDECL import,bbGfxDriverName( int n ),pointer 
DECLARE CDECL import,bbGfxDriver3D( int n ),int

DECLARE CDECL import,bbGfxDriverCaps3D(),int

DECLARE CDECL import,bbCountGfxModes3D(),int
DECLARE CDECL import,bbGfxMode3DExists( int w,int h,int d ),int
DECLARE CDECL import,bbGfxMode3D( int n ),int
DECLARE CDECL import,bbWindowed3D(),int

DECLARE CDECL import,bbGfxDriverX( int n ),int
DECLARE CDECL import,bbGfxDriverY( int n ),int
DECLARE CDECL import,bbGfxDriverHz( int n ),int

DECLARE CDECL import,bbSetGfxDriver( int n )
DECLARE CDECL import,bbGfxModeExists( int w,int h,int d ),int
DECLARE CDECL import,bbCountGfxModes(),int

DECLARE CDECL import,bbGfxModeWidth( int n ),int
DECLARE CDECL import,bbGfxModeHeight( int n ),int
DECLARE CDECL import,bbGfxModeDepth( int n ),int

DECLARE CDECL import,bbGraphicsWidth(),int
DECLARE CDECL import,bbGraphicsHeight(),int
DECLARE CDECL import,bbGraphicsDepth(),int

DECLARE CDECL import,bbAvailVidMem(),int
DECLARE CDECL import,bbTotalVidMem(),int

'mode functions

DECLARE CDECL import,bbGraphics( int w,int h,int d,int mode )
DECLARE CDECL import,bbFrontBuffer(),BBCanvas
DECLARE CDECL import,bbBackBuffer(),BBCanvas
DECLARE CDECL import,bbGraphicsLost(),int
DECLARE CDECL import,bbEndGraphics()
DECLARE CDECL import,bbScanLine(),int
DECLARE CDECL import,bbVWait( int n )

DECLARE CDECL import,bbFlip(OPT int vwait=1 )

DECLARE CDECL import,bbPaint( int hwnd )

'graphics buffer functions

DECLARE CDECL import,bbSetBuffer(BBCanvas buff)
DECLARE CDECL import,bbGraphicsBuffer(),BBCanvas
DECLARE CDECL import,bbLoadBuffer(BBCanvas surf, pointer str),int
DECLARE CDECL import,bbSaveBuffer(BBCanvas surf, pointer str),int
DECLARE CDECL import,bbBufferDirty(BBCanvas buffer)
DECLARE CDECL import,bbAutoBufferDirty(int enable)

'fast read/write operations...

DECLARE CDECL import,bbLockBuffer( BBCanvas buff )
DECLARE CDECL import,bbUnlockBuffer( BBCanvas buff )
DECLARE CDECL import,bbReadPixel( int x,int y,BBCanvas buff ),int
DECLARE CDECL import,bbWritePixel( int x,int y,int argb,BBCanvas buff )
DECLARE CDECL import,bbReadPixelFast( int x,int y,BBCanvas buff ),int
DECLARE CDECL import,bbWritePixelFast( int x,int y,int argb,BBCanvas buff )
DECLARE CDECL import,bbCopyPixel( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff )
DECLARE CDECL import,bbCopyPixelFast( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff )

'2d rendering functions

DECLARE CDECL import,bbOrigin( int x,int y )
DECLARE CDECL import,bbViewport( int x,int y,int w,int h )
DECLARE CDECL import,bbColor( int r,int g,int b )
DECLARE CDECL import,bbClsColor( int r,int g,int b )
DECLARE CDECL import,bbCls()
DECLARE CDECL import,bbPlot( int x,int y )
DECLARE CDECL import,bbLine( int x1,int y1,int x2,int y2 )

DECLARE CDECL import,bbRect( int x,int y,int w,int h,OPT int solid=1 )
DECLARE CDECL import,bbOval( int x,int y,int w,int h,OPT int solid=1 )
DECLARE CDECL import,bbText( int x,int y, pointer t,OPT int centre_x=0,OPT int centre_y=0 )

DECLARE CDECL import,bbCopyRect( int sx,int sy,int w,int h,int dx,int dy,BBCanvas src,BBCanvas dest )
DECLARE CDECL import,bbGetColor( int x,int y )
DECLARE CDECL import,bbColorRed(),int
DECLARE CDECL import,bbColorGreen(),int
DECLARE CDECL import,bbColorBlue(),int

'font functions

DECLARE CDECL import,bbLoadFont(  pointer name,int height,int bold,int italic,int underline ),BBFont
DECLARE CDECL import,bbFreeFont( BBFont f )
DECLARE CDECL import,bbSetFont( BBFont f )
DECLARE CDECL import,bbFontWidth(),int
DECLARE CDECL import,bbFontHeight(),int
DECLARE CDECL import,bbStringWidth(  pointer str ),int
DECLARE CDECL import,bbStringHeight(  pointer str ),int

'image functions

DECLARE CDECL import,bbLoadImage(  pointer s ),BBImage
DECLARE CDECL import,bbCopyImage( BBImage sourceimage ),BBImage
DECLARE CDECL import,bbCreateImage( int w,int h,int n ),BBImage
DECLARE CDECL import,bbLoadAnimImage(  pointer s,int w,int h,int first,int cnt ),BBImage
DECLARE CDECL import,bbFreeImage( BBImage i )
DECLARE CDECL import,bbSaveImage( BBImage i, pointer filename,int frame ),int
DECLARE CDECL import,bbGrabImage( BBImage i,int x,int y,int n )
DECLARE CDECL import,bbImageBuffer( BBImage i,int n ),BBCanvas
DECLARE CDECL import,bbDrawImage( BBImage i,int x,int y,int frame )
DECLARE CDECL import,bbDrawBlock( BBImage i,int x,int y,int frame )
DECLARE CDECL import,bbTileImage( BBImage i,int x,int y,int frame )
DECLARE CDECL import,bbTileBlock( BBImage i,int x,int y,int frame )
DECLARE CDECL import,bbDrawImageRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame )
DECLARE CDECL import,bbDrawBlockRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame )
DECLARE CDECL import,bbMaskImage( BBImage i,int r,int g,int b )
DECLARE CDECL import,bbHandleImage( BBImage i,int x,int y )
DECLARE CDECL import,bbScaleImage( BBImage i,float w,float h )
DECLARE CDECL import,bbResizeImage( BBImage i,float w,float h )
DECLARE CDECL import,bbRotateImage( BBImage i,float angle )
DECLARE CDECL import,bbTFormImage( BBImage i,float a,float b,float c,float d )
DECLARE CDECL import,bbTFormFilter( int enable )
DECLARE CDECL import,bbAutoMidHandle( int enable )
DECLARE CDECL import,bbMidHandle( BBImage i )
DECLARE CDECL import,bbImageWidth( BBImage i ),int
DECLARE CDECL import,bbImageHeight( BBImage i ),int
DECLARE CDECL import,bbImageXHandle( BBImage i ),int
DECLARE CDECL import,bbImageYHandle( BBImage i ),int
DECLARE CDECL import,bbImagesOverlap( BBImage i1,int x1,int y1,BBImage i2,int x2,int y2 ),int
DECLARE CDECL import,bbImagesCollide( BBImage i1,int x1,int y1,int f1,BBImage i2,int x2,int y2,int f2 ),int
DECLARE CDECL import,bbRectsOverlap( int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2 ),int
DECLARE CDECL import,bbImageRectOverlap( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h ),int
DECLARE CDECL import,bbImageRectCollide( BBImage i,int x,int y,int f,int r_x,int r_y,int r_w,int r_h ),int

DECLARE CDECL import,bbWrite(  pointer str )
DECLARE CDECL import,bbPrint(  pointer str )
DECLARE CDECL import,bbInput(  pointer prompt ),pointer 
DECLARE CDECL import,bbLocate( int x,int y )

' movie commands

DECLARE CDECL import,bbOpenMovie(  pointer s ),BBMovie
DECLARE CDECL import,bbDrawMovie( BBMovie movie,int x,int y,int w,int h ),int
DECLARE CDECL import,bbMovieWidth( BBMovie movie ),int
DECLARE CDECL import,bbMovieHeight( BBMovie movie ),int
DECLARE CDECL import,bbMoviePlaying( BBMovie movie ),int
DECLARE CDECL import,bbCloseMovie( BBMovie movie )

' gamma commands

DECLARE CDECL import,bbSetGamma( int r,int g,int b,float dr,float dg,float db )
DECLARE CDECL import,bbUpdateGamma( int calibrate )
DECLARE CDECL import,bbGammaRed( int n ),float
DECLARE CDECL import,bbGammaGreen( int n ),float
DECLARE CDECL import,bbGammaBlue( int n ),float

' bbgraphics3d

' global world commands 

DECLARE CDECL import,bbLoaderMatrix(  pointer ext,float xx,float xy,float xz,float yx,float yy,float yz,float zx,float zy,float zz )
DECLARE CDECL import,bbHWTexUnits(),int

DECLARE CDECL import,bbHWMultiTex( int enable )
DECLARE CDECL import,bbWBuffer( int enable )
DECLARE CDECL import,bbDither( int enable )
DECLARE CDECL import,bbAntiAlias( int enable )
DECLARE CDECL import,bbWireFrame( int enable )
DECLARE CDECL import,bbAmbientLight( float r,float g,float b )
DECLARE CDECL import,bbClearCollisions()

DECLARE CDECL import,bbCollisions( int src_type,int dest_type,int method,int response )

DECLARE CDECL import,bbUpdateWorld( OPT float elapsed=1.0f )
DECLARE CDECL import,bbRenderWorld( OPT float tween=1.0f )

DECLARE CDECL import,bbCaptureWorld()
DECLARE CDECL import,bbTrisRendered(),int
DECLARE CDECL import,bbStats3D( int n ),float

' texture commands

DECLARE CDECL import,bbLoadTexture(  pointer ifile,OPT int flags=1 ),BBTexture
DECLARE CDECL import,bbCreateTexture( int w,int h,OPT int flags=3,OPT int frames=1 ),BBTexture

DECLARE CDECL import,bbLoadAnimTexture(  pointer ifile,int flags,int w,int h,int first,int cnt ),BBTexture
DECLARE CDECL import,bbFreeTexture( BBTexture t )
DECLARE CDECL import,bbTextureBlend( BBTexture t,int blend )
DECLARE CDECL import,bbTextureCoords( BBTexture t,int flags )
DECLARE CDECL import,bbScaleTexture( BBTexture t,float u_scale,float v_scale )
DECLARE CDECL import,bbRotateTexture( BBTexture t,float angle )
DECLARE CDECL import,bbPositionTexture( BBTexture t,float u_pos,float v_pos )
DECLARE CDECL import,bbTextureWidth( BBTexture t ),int
DECLARE CDECL import,bbTextureHeight( BBTexture t ),int

DECLARE CDECL import,bbTextureName( BBTexture t ),pointer 
DECLARE CDECL import,bbSetCubeFace( BBTexture t,int face )
DECLARE CDECL import,bbSetCubeMode( BBTexture t,int mode )

DECLARE CDECL import,bbTextureBuffer( BBTexture t,OPT int frame=0 ),BBCanvas 

DECLARE CDECL import,bbClearTextureFilters()
DECLARE CDECL import,bbTextureFilter(pointer t,int flags )

' brush commands


DECLARE CDECL import,bbCreateBrush( OPT float r=255.0f,OPT float g=255.0f,OPT float b=255.0f ),BBBrush
DECLARE CDECL import,bbLoadBrush(pointer ifile,OPT int flags=1,OPT float u_scale=1.0f,OPT float v_scale=1.0f ),BBBrush

DECLARE CDECL import,bbFreeBrush( BBBrush b )
DECLARE CDECL import,bbBrushColor( BBBrush br,float r,float g,float b )
DECLARE CDECL import,bbBrushAlpha( BBBrush b,float alpha )
DECLARE CDECL import,bbBrushShininess( BBBrush b,float n )
DECLARE CDECL import,bbBrushTexture( BBBrush b,BBTexture t,int frame,int index )
DECLARE CDECL import,bbGetBrushTexture( BBBrush b,int index ),BBTexture
DECLARE CDECL import,bbBrushBlend( BBBrush b,int blend )
DECLARE CDECL import,bbBrushFX( BBBrush b,int fx )

' mesh commands

DECLARE CDECL import,bbCreateMesh( OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbLoadMesh(  pointer f,OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbLoadAnimMesh(  pointer f,OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbCreateCube( OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbCreateSphere( OPT int segs=8,OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbCreateCylinder( OPT int segs=8,OPT int solid=1,OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbCreateCone( OPT int segs=8,OPT int solid=1,OPT BBEntity p=0 ),BBModel
DECLARE CDECL import,bbCopyMesh( BBModel m,OPT BBEntity p=0 ),BBModel

DECLARE CDECL import,bbScaleMesh( BBModel m,float x,float y,float z )
DECLARE CDECL import,bbRotateMesh( BBModel m,float x,float y,float z )
DECLARE CDECL import,bbPositionMesh( BBModel m,float x,float y,float z )

DECLARE CDECL import,bbFitMesh( BBModel m,float x,float y,float z,float w,float h,float d,OPT int uniform=0 )

DECLARE CDECL import,bbFlipMesh( BBModel m )
DECLARE CDECL import,bbPaintMesh( BBModel m,BBBrush b )
DECLARE CDECL import,bbAddMesh( BBModel src,BBModel dest )
DECLARE CDECL import,bbUpdateNormals( BBModel m )
DECLARE CDECL import,bbLightMesh( BBModel m,float r,float g,float b,float range,float x,float y,float z )
DECLARE CDECL import,bbMeshWidth( BBModel m ),float
DECLARE CDECL import,bbMeshHeight( BBModel m ),float
DECLARE CDECL import,bbMeshDepth( BBModel m ),float
DECLARE CDECL import,bbMeshesIntersect( BBModel a,BBModel b ),int
DECLARE CDECL import,bbCountSurfaces( BBModel m ),int
DECLARE CDECL import,bbGetSurface( BBModel m,int index ),BBSurface
DECLARE CDECL import,bbMeshCullBox( BBModel m,float x,float y,float z,float w,float h,float d )

' surface commands

DECLARE CDECL import,bbCreateSurface( BBModel m,OPT BBBrush b=0 ),BBSurface

DECLARE CDECL import,bbFindSurface( BBModel m,BBBrush b ),BBSurface
DECLARE CDECL import,bbGetSurfaceBrush( BBSurface s ),BBBrush
DECLARE CDECL import,bbGetEntityBrush( BBModel m ),BBBrush

DECLARE CDECL import,bbClearSurface( BBSurface s,int verts,int tris )
DECLARE CDECL import,bbPaintSurface( BBSurface s,BBBrush b )

DECLARE CDECL import,bbAddVertex( BBSurface s,float x,float y,float z,OPT float tu=0.0f,OPT float tv=0.0f,OPT float tw=0.0f ),int

DECLARE CDECL import,bbAddTriangle( BBSurface s,int v0,int v1,int v2 ),int
DECLARE CDECL import,bbVertexCoords( BBSurface s,int n,float x,float y,float z )
DECLARE CDECL import,bbVertexNormal( BBSurface s,int n,float x,float y,float z )

DECLARE CDECL import,bbVertexColor( BBSurface s,int n,float r,float g,float b,float a )
DECLARE CDECL import,bbVertexTexCoords( BBSurface s,int n,float u,float v,float w,int set )
DECLARE CDECL import,bbCountVertices( BBSurface s ),int
DECLARE CDECL import,bbCountTriangles( BBSurface s ),int
DECLARE CDECL import,bbVertexX( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexY( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexZ( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexNX( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexNY( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexNZ( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexRed( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexGreen( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexBlue( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexAlpha( BBSurface s,int n ),float
DECLARE CDECL import,bbVertexU( BBSurface s,int n,int t ),float
DECLARE CDECL import,bbVertexV( BBSurface s,int n,int t ),float
DECLARE CDECL import,bbVertexW( BBSurface s,int n,int t ),float
DECLARE CDECL import,bbTriangleVertex( BBSurface s,int n,int v ),int

' camera commands

DECLARE CDECL import,bbCreateCamera( OPT BBEntity p=0 ),BBCamera

DECLARE CDECL import,bbCameraZoom( BBCamera c,float zoom )
DECLARE CDECL import,bbCameraRange( BBCamera c,float nr,float fr )
DECLARE CDECL import,bbCameraClsColor( BBCamera c,float r,float g,float b )
DECLARE CDECL import,bbCameraClsMode( BBCamera c,int cls_color,int cls_zbuffer )
DECLARE CDECL import,bbCameraProjMode( BBCamera c,int mode )
DECLARE CDECL import,bbCameraViewport( BBCamera c,int x,int y,int w,int h )
DECLARE CDECL import,bbCameraFogRange( BBCamera c,float nr,float fr )
DECLARE CDECL import,bbCameraFogColor( BBCamera c,float r,float g,float b )
DECLARE CDECL import,bbCameraFogMode( BBCamera c,int mode )
DECLARE CDECL import,bbCameraProject( BBCamera c,float x,float y,float z ),int
DECLARE CDECL import,bbProjectedX(),float
DECLARE CDECL import,bbProjectedY(),float
DECLARE CDECL import,bbProjectedZ(),float
DECLARE CDECL import,bbCameraPick( BBCamera c,float x,float y ),BBEntity
DECLARE CDECL import,bbLinePick( float x,float y,float z,float dx,float dy,float dz,float radius ),BBEntity
DECLARE CDECL import,bbEntityPick( INT src,float range ),BBEntity
DECLARE CDECL import,bbEntityVisible( INT src,INT dest ),int
DECLARE CDECL import,bbEntityInView( BBEntity e,BBCamera c ),int
DECLARE CDECL import,bbPickedX(),float
DECLARE CDECL import,bbPickedY(),float
DECLARE CDECL import,bbPickedZ(),float
DECLARE CDECL import,bbPickedNX(),float
DECLARE CDECL import,bbPickedNY(),float
DECLARE CDECL import,bbPickedNZ(),float
DECLARE CDECL import,bbPickedTime(),float
DECLARE CDECL import,bbPickedEntity(),INT
DECLARE CDECL import,bbPickedSurface(),BBSurface
DECLARE CDECL import,bbPickedTriangle(),int

' light commands

DECLARE CDECL import,bbCreateLight( OPT int itype=0,OPT BBEntity p=0 ),BBLight

DECLARE CDECL import,bbLightColor( BBLight light,float r,float g,float b )
DECLARE CDECL import,bbLightRange( BBLight light,float range )
DECLARE CDECL import,bbLightConeAngles( BBLight light,float inner,float outer )

' pivot commands
DECLARE CDECL import,bbCreatePivot( OPT BBEntity p=0 ),BBPivot

' sprite commands

DECLARE CDECL import,bbCreateSprite( OPT BBEntity p=0 ),BBSprite
DECLARE CDECL import,bbLoadSprite(  pointer ifile,OPT int flags=1,OPT BBEntity p=0 ),BBSprite

DECLARE CDECL import,bbRotateSprite( BBSprite s,float angle )
DECLARE CDECL import,bbScaleSprite( BBSprite s,float x,float y )
DECLARE CDECL import,bbHandleSprite( BBSprite s,float x,float y )
DECLARE CDECL import,bbSpriteViewMode( BBSprite s,int mode )

' mirror commands

DECLARE CDECL import,bbCreateMirror( OPT BBEntity p=0 ),BBMirror


' plane commands

DECLARE CDECL import,bbCreatePlane( OPT int segs=1,OPT BBEntity p=0 ),BBPlaneModel


' md2 commands

DECLARE CDECL import,bbLoadMD2( pointer ifile,OPT BBEntity p=0 ),BBMD2Model
DECLARE CDECL import,bbAnimateMD2( BBMD2Model m,OPT int mode=1,OPT float speed=1.0f,OPT int first=0,OPT int last=9999,OPT float trans=0.0f )

DECLARE CDECL import,bbMD2AnimTime( BBMD2Model m ),float
DECLARE CDECL import,bbMD2AnimLength( BBMD2Model m ),int
DECLARE CDECL import,bbMD2Animating( BBMD2Model m ),int

' bsp commands

DECLARE CDECL import,bbLoadBSP(pointer ifile,float gam,OPT BBEntity p=0 ),BBQ3BSPModel

DECLARE CDECL import,bbBSPAmbientLight( BBQ3BSPModel t,float r,float g,float b )
DECLARE CDECL import,bbBSPLighting( BBQ3BSPModel t,int lmap )

' terrain commands

DECLARE CDECL import,bbCreateTerrain( int n,OPT BBEntity p=0 ),BBTerrain
DECLARE CDECL import,bbLoadTerrain(pointer ifile,OPT BBEntity p=0 ),BBTerrain

DECLARE CDECL import,bbTerrainDetail( BBTerrain t,int n,int m )
DECLARE CDECL import,bbTerrainShading( BBTerrain t,int enable )
DECLARE CDECL import,bbTerrainX( BBTerrain t,float x,float y,float z ),float
DECLARE CDECL import,bbTerrainY( BBTerrain t,float x,float y,float z ),float
DECLARE CDECL import,bbTerrainZ( BBTerrain t,float x,float y,float z ),float
DECLARE CDECL import,bbTerrainSize( BBTerrain t ),int
DECLARE CDECL import,bbTerrainHeight( BBTerrain t,int x,int z ),float
DECLARE CDECL import,bbModifyTerrain( BBTerrain t,int x,int z,float h,int realtime )

' audio commands

DECLARE CDECL import,bbCreateListener( OPT BBEntity p=0,OPT float roll=1.0f,OPT float dopp=1.0f,OPT float dist=1.0f ),BBEntity

DECLARE CDECL import,bbEmitSound( BBSound sound,INT o ),BBChannel

' entity commands

DECLARE CDECL import,bbCopyEntity( BBEntity e,OPT BBEntity p=0 ),BBEntity

DECLARE CDECL import,bbFreeEntity( BBEntity e )
DECLARE CDECL import,bbHideEntity( BBEntity e )
DECLARE CDECL import,bbShowEntity( BBEntity e )

DECLARE CDECL import,bbEntityParent( BBEntity e,OPT BBEntity p=0,OPT int iglobal=1 )

DECLARE CDECL import,bbCountChildren( BBEntity e ),int
DECLARE CDECL import,bbGetChild( BBEntity e,int index ),BBEntity
DECLARE CDECL import,bbFindChild( BBEntity e, pointer t ),BBEntity

' animation commands

DECLARE CDECL import,bbLoadAnimSeq( INT o, pointer f ),int
DECLARE CDECL import,bbSetAnimTime( INT o,float time,int seq )

DECLARE CDECL import,bbAnimate( INT o,OPT int mode=1,OPT float speed=1.0f,OPT int seq=0,OPT float trans=0.0f )
DECLARE CDECL import,bbSetAnimKey( INT o,int frame,OPT int pos_key=1,OPT int rot_key=1,OPT int scl_key=1 )

DECLARE CDECL import,bbExtractAnimSeq( INT o,int first,int last,int seq ),int
DECLARE CDECL import,bbAddAnimSeq( INT o,int length ),int
DECLARE CDECL import,bbAnimSeq( INT o ),int
DECLARE CDECL import,bbAnimTime( INT o ),float
DECLARE CDECL import,bbAnimLength( INT o ),int
DECLARE CDECL import,bbAnimating( INT o ),int

' entity special fx commands

DECLARE CDECL import,bbPaintEntity( BBEntity e,BBBrush b )
DECLARE CDECL import,bbEntityColor( BBModel m,float r,float g,float b )
DECLARE CDECL import,bbEntityAlpha( BBModel m,float alpha )
DECLARE CDECL import,bbEntityShininess( BBModel m,float shininess )

DECLARE CDECL import,bbEntityTexture( BBModel m,BBTexture t,OPT int frame=0,OPT int index=0 )

DECLARE CDECL import,bbEntityBlend( BBModel m,int blend )
DECLARE CDECL import,bbEntityFX( BBModel m,int fx )
DECLARE CDECL import,bbEntityAutoFade( BBModel m,float nr,float fr )
DECLARE CDECL import,bbEntityOrder( INT o,int n )

' entity property commands


DECLARE CDECL import,bbEntityX( BBEntity e,OPT int iglobal=0 ),float
DECLARE CDECL import,bbEntityY( BBEntity e,OPT int iglobal=0 ),float
DECLARE CDECL import,bbEntityZ( BBEntity e,OPT int iglobal=0 ),float
DECLARE CDECL import,bbEntityPitch( BBEntity e,OPT int iglobal=0 ),float
DECLARE CDECL import,bbEntityYaw( BBEntity e,OPT int iglobal=0 ),float
DECLARE CDECL import,bbEntityRoll( BBEntity e,OPT int iglobal=0 ),float

DECLARE CDECL import,bbGetMatElement( BBEntity e,int row,int col ),float
DECLARE CDECL import,bbTFormPoint( float x,float y,float z,BBEntity src,BBEntity dest )
DECLARE CDECL import,bbTFormVector( float x,float y,float z,BBEntity src,BBEntity dest )
DECLARE CDECL import,bbTFormNormal( float x,float y,float z,BBEntity src,BBEntity dest )
DECLARE CDECL import,bbTFormedX(),float
DECLARE CDECL import,bbTFormedY(),float
DECLARE CDECL import,bbTFormedZ(),float
DECLARE CDECL import,bbVectorYaw( float x,float y,float z ),float
DECLARE CDECL import,bbVectorPitch( float x,float y,float z ),float
DECLARE CDECL import,bbDeltaYaw( BBEntity src,BBEntity dest ),float
DECLARE CDECL import,bbDeltaPitch( BBEntity src,BBEntity dest ),float

' entity collision commands

DECLARE CDECL import,bbResetEntity( INT o )
DECLARE CDECL import,bbCaptureEntity( INT o )

DECLARE CDECL import,bbEntityType( INT o,int itype,OPT int recurs=0 )

DECLARE CDECL import,bbEntityPickMode( INT o,int mode,int obs )
DECLARE CDECL import,bbGetParent( BBEntity e ),BBEntity
DECLARE CDECL import,bbGetEntityType( INT o ),int

DECLARE CDECL import,bbEntityRadius( INT o,float x_radius,OPT float y_radius=0.0f )

DECLARE CDECL import,bbEntityBox( INT o,float x,float y,float z,float w,float h,float d )
DECLARE CDECL import,bbEntityCollided( INT o,int itype ),INT
DECLARE CDECL import,bbCountCollisions( INT o ),int
DECLARE CDECL import,bbCollisionX( INT o,int index ),float
DECLARE CDECL import,bbCollisionY( INT o,int index ),float
DECLARE CDECL import,bbCollisionZ( INT o,int index ),float
DECLARE CDECL import,bbCollisionNX( INT o,int index ),float
DECLARE CDECL import,bbCollisionNY( INT o,int index ),float
DECLARE CDECL import,bbCollisionNZ( INT o,int index ),float
DECLARE CDECL import,bbCollisionTime( INT o,int index ),float
DECLARE CDECL import,bbCollisionEntity( INT o,int index ),INT
DECLARE CDECL import,bbCollisionSurface( INT o,int index ),BBSurface
DECLARE CDECL import,bbCollisionTriangle( INT o,int index ),int
DECLARE CDECL import,bbEntityDistance( BBEntity src,BBEntity dest ),float

' entity transformation commands

DECLARE CDECL import,bbMoveEntity( BBEntity e,float x,float y,float z )

DECLARE CDECL import,bbTurnEntity( BBEntity e,float p,float y,float r,OPT int iglobal=0 )
DECLARE CDECL import,bbTranslateEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 )
DECLARE CDECL import,bbPositionEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 )
DECLARE CDECL import,bbScaleEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 )
DECLARE CDECL import,bbRotateEntity( BBEntity e,float p,float y,float r,OPT int iglobal=0 )
DECLARE CDECL import,bbPointEntity( BBEntity e,BBEntity t,OPT float roll=0 )

DECLARE CDECL import,bbAlignToVector( BBEntity e,float nx,float ny,float nz,int axis,float rate )

' entity misc commands

DECLARE CDECL import,bbNameEntity( BBEntity e, pointer t )
DECLARE CDECL import,bbEntityName( BBEntity e ),pointer 
DECLARE CDECL import,bbEntityClass( BBEntity e ),pointer 
DECLARE CDECL import,bbClearWorld( int e,int b,int t )
DECLARE CDECL import,bbSetEntityID( pointer e,int id )
DECLARE CDECL import,bbEntityID( pointer e ),int

DECLARE CDECL import,bbActiveTextures(),int